<?xml version="1.0" encoding="UTF-8"?>
<record_update table="sp_widget">
    <sp_widget action="INSERT_OR_UPDATE">
        <client_script><![CDATA[function (spUtil, $scope, $timeout, $http) {
    /* widget controller */
    var c = this;
	
	$scope.gameOver = function() {
	//  alert("Game over man");	
	};
	
	$scope.checkSlide = function() {
		if (this.data.knowledge_slide)
		return true;
		else
			return false;
		
	};
	$scope.checkScheduled = function() {
		if (this.data.state == "Scheduled")
		return true;
		else
			return false;
		
	};
	
	$scope.checkPreparing = function() {
		if (this.data.state == "Preparing")
			{
			  $scope.data.answer_points = "";
				$scope.data.show_answer_points = "";
		      return true;
			}
		else
			return false;
		
	};
	
	$scope.checkAsking = function() {
		if (this.data.state == "Asking")
		return true;
		else
			return false;
		
	};
	
	$scope.checkNotify = function() {
		if (this.data.notify == true && this.data.state != "Scheduled" && this.data.state != "Game Over")
		return true;
		else
			return false;
		
	};
	$scope.checkShowScores = function() {
		if (this.data.state == "Showing Scores" || this.data.state == "Game Over")
			{
				if ($scope.answer_points != "") {
			     $scope.data.show_answer_points = "Points earned: " + $scope.data.answer_points;
				}
				else
					{
						$scope.data.show_answer_points = "Why you no answer?";
					}
		      return true;
			}
		else
			return false;
		
	};
	$scope.checkGameOver = function() {
		if (this.data.state == "Game Over")
			{
			  $scope.data.answer_points = "";
				$scope.data.show_answer_points = "";
		      return true;
			}
		else
			return false;
		
	};
    spUtil.recordWatch($scope, "x_9104_trivia_now_game", "sys_id="+this.data.sys_id, function(name, data) {
		console.log(data);
        c.server.update();
        $timeout(function() {
            $scope.changeBg();
        }, 500);  
    });
 
    $scope.changeBg = function() {
        $timeout(function() {
		//	$scope.data.answer_points = "";
        }, 500);
    };
	
	
	$scope.setAnswer = function(answerId) {
		var playerId = $scope.data.player_id;
		var gameId = $scope.data.sys_id;
		var questionId = $scope.data.question_id;
		parseQuery(playerId,gameId,questionId,answerId);
		
		function parseQuery(playerId,gameId,questionId,answerId) {
			var parameter = JSON.stringify({game: gameId, player: playerId, question: questionId, answer: answerId });
			var z = $http.post('/api/x_9104_trivia_now/trivianow/post_answer', parameter
			).then(function(response) {
				if (response && response.data && response.data.result)
					$scope.data.returnValue = response.data.result.points;
				   $scope.data.answer_points = response.data.result.points;
				    
			});
		}
		
	};

}

]]></client_script>
        <controller_as>c</controller_as>
        <css>.btn-group {&#13;
  padding-left: 5px;&#13;
  padding-right: 5px;&#13;
}&#13;
&#13;
#slide_image {&#13;
  border: 1px solid black;&#13;
}&#13;
&#13;
#table_score {&#13;
  font-size: 20px;&#13;
}&#13;
&#13;
#image_section {&#13;
  margin: auto;&#13;
  text-align: center;&#13;
}&#13;
&#13;
.left_column {&#13;
  font-weight: bold;&#13;
}&#13;
&#13;
.center_column {&#13;
}&#13;
&#13;
.right_column {&#13;
  font-weight: bold;&#13;
}&#13;
&#13;
&#13;
#answer_section {&#13;
    text-align: center;&#13;
    margin: auto;&#13;
}&#13;
#answer_list {&#13;
  text-align: left;&#13;
  font-size: 20px&#13;
}&#13;
&#13;
#game_asking {&#13;
  margin: auto;&#13;
  text-align: center;&#13;
}&#13;
&#13;
.status_header {&#13;
  text-align: center;&#13;
  font-size: 30px;&#13;
  font-weight:bold;&#13;
&#13;
}&#13;
&#13;
.header_info {&#13;
  font-size: 35px;&#13;
  width: auto;&#13;
  margin: auto;&#13;
&#13;
}&#13;
&#13;
#notify_text {&#13;
  padding: 10px;&#13;
}&#13;
&#13;
#notify_number {&#13;
  font-weight: bold;&#13;
  text-align: center;&#13;
  font-size: 40px;&#13;
}&#13;
&#13;
#footer {&#13;
  text-align: center;&#13;
  margin: auto;&#13;
  padding: 10px;&#13;
}&#13;
&#13;
#timer {&#13;
  font-size: 20px;&#13;
}&#13;
&#13;
#clock {&#13;
  &#13;
}&#13;
&#13;
.answer_col {&#13;
  padding: 10px;&#13;
  background: red;&#13;
}&#13;
&#13;
&#13;
</css>
        <data_table>sp_instance</data_table>
        <demo_data/>
        <description>Contestant widget for Trivia Now</description>
        <docs/>
        <field_list/>
        <has_preview>false</has_preview>
        <id>tn-contestant</id>
        <internal>false</internal>
        <link/>
        <name>Trivia Now Contestant</name>
        <option_schema/>
        <public>true</public>
        <roles/>
        <script><![CDATA[(function($sp, input, data, options, gs) {
	  data.sys_id = $sp.getParameter("sys_id") || input.sys_id;
	  data.player_id = $sp.getParameter("player_id");
	  var gameGR = new GlideRecord('x_9104_trivia_now_game');
	  gameGR.get(data.sys_id);
	  data.notify = gameGR.getValue('notify');
	  data.scheduled_date = gameGR.getDisplayValue('start_date_time');
	  if (data.notify == true) {
		  data.notify_message = gs.getProperty('x_9104_trivia_now.notify_instructions');
		  var temp_number = gameGR.notify_number.getDisplayValue();
		  data.notify_number = temp_number.substring(0,2) + " " + temp_number.substring(2,5) + " " + temp_number.substring(5,8) + " " + temp_number.substring(8,12);
	  }
	data.use_slides = gameGR.getValue('use_slides');
	data.knowledge_slide = gameGR.getValue('knowledge_slide');
	  if (data.use_slides && data.slide_value != "") {
		  data.image_alt = "Knowledge Slide";
		  var imageGR = new GlideRecord('x_9104_trivia_now_slide');
		  imageGR.addQuery('name',data.knowledge_slide);
		  imageGR.query();
		  if (imageGR.next()) {
			  data.image_name = imageGR.image.getDisplayValue();
			  data.image_height = imageGR.image.height.getDisplayValue();
			  data.image_width = imageGR.image.width.getDisplayValue();
			  gs.debug("Image name is " + imageGR.image.getDisplayValue());
		  }
	  }
	  data.question = gameGR.current_question.getDisplayValue();
	  data.question_id = gameGR.getValue('current_question');
	  data.state = gameGR.state.getDisplayValue();
	  if (data.state == 'Asking') {
		  var currentDateTime = new GlideDateTime();
		  var questionEndDateTime = new GlideDateTime(gameGR.getValue('sys_updated_on'));
		  var questionTimeLimit = parseInt(gameGR.game_template.time_limit.getDisplayValue());
		  var timePassed = new GlideDuration();
    	  timePassed = (GlideDateTime.subtract(questionEndDateTime,currentDateTime));
		  var timePassedSec = parseInt(timePassed.getNumericValue()/1000);
		  data.timeRemaining = parseInt(questionTimeLimit - timePassedSec);
		  
		  var answerSysID = [];
		  gs.debug("String answer from game is " + gameGR.notify_answers);
		  answerSysID = gameGR.notify_answers.split(",");
		  gs.debug("answersysid is " + answerSysID[0]);
		  data.answers = [];
		  for (i=0;i < answerSysID.length;i++) {
			  gs.debug("Widget answer sys ID is " + answerSysID[i]);
			  var answer_records = {};
			  var findAnswers = new GlideRecord('x_9104_trivia_now_answer');
			  findAnswers.get(answerSysID[i]);
			  answer_records.answer = findAnswers.getDisplayValue();
			  answer_records.sys_id = answerSysID[i];
			  answer_records.number = i+1 + ". ";
			  data.answers.push(answer_records);
		  }
		  
	  }
	
	if (data.state == 'Showing Scores' || 'Game Over')
		{
			var scoreGR = new GlideRecord('x_9104_trivia_now_m2m_players_games');
			scoreGR.addQuery('game',data.sys_id);
			scoreGR.orderByDesc('score');
			scoreGR.query();
			data.scores = [];
			while (scoreGR.next()) {
				var score_records = {};
				score_records.player = scoreGR.getDisplayValue('player');
				score_records.score = scoreGR.getValue('score');
				if (data.notify) {
					score_records.mobile_number = scoreGR.player.mobile_number.getDisplayValue();
				}
				data.scores.push(score_records);
			}
		}

	
})($sp, input, data, options, gs);]]></script>
        <servicenow>false</servicenow>
        <sys_class_name>sp_widget</sys_class_name>
        <sys_created_by>admin</sys_created_by>
        <sys_created_on>2017-09-05 13:21:33</sys_created_on>
        <sys_id>7115d381db454f006cedfd131d9619c2</sys_id>
        <sys_mod_count>166</sys_mod_count>
        <sys_name>Trivia Now Contestant</sys_name>
        <sys_package display_value="Trivia Now" source="x_9104_trivia_now">08b986534f2322005ec7c3818110c7fc</sys_package>
        <sys_policy/>
        <sys_scope display_value="Trivia Now">08b986534f2322005ec7c3818110c7fc</sys_scope>
        <sys_update_name>sp_widget_7115d381db454f006cedfd131d9619c2</sys_update_name>
        <sys_updated_by>michael.slabodnick</sys_updated_by>
        <sys_updated_on>2017-09-29 15:43:13</sys_updated_on>
        <template><![CDATA[<div id="game_wrapper" ng-controller="triviaNowController">
  <div id = "slide_section" ng-hide="!checkSlide()">
      <div id="image_section">
       <img id="slide_image" src="{{data.image_name}}" border = 5 alt="{{data.image_alt}}" style="width:{{data.image_width}}px;height:{{data.image_height}}px;">
     </div>
    </div>
  <div id = "no_knowledge_slide" ng-hide="checkSlide()">
  <div id="preparing" class="jumbotron text-center" ng-hide="!checkPreparing()">
    Preparing Next Question...
  </div>
   <div id="scheduled" class="jumbotron text-center" ng-hide="!checkScheduled()">
    Scheduled Game
    
     <div id="scheduled_info" class="header_info"> {{data.scheduled_date}}
     </div>
    </div>
  <div id="notify_info" class="header_info" ng-hide="!checkNotify()">
    <div id="notify_text">{{data.notify_message}}  
      <div id="notify_number"> {{data.notify_number}}
      </div>
    </div>
  </div>
    <!-- Section for question -->
  <div id="game_asking" ng-hide="!checkAsking()">
    <div class="container">
       <div class="row">
         <div id="game_question" class="bg-primary text-center page-header"><h4>{{data.question}} </h4> </div> 
      </div>
      <div id="answer_row" class="row btn-group btn-group-vertical text-center">
          <button  type="button" ng-click = "setAnswer(item.sys_id)" class="btn btn-primary btn-lg answer_button" ng-repeat="item in data.answers track by item.sys_id">{{item.answer}}</button> 
       <div id="answer_points" class="row">  </div> 
    </div>
   </div>
    
  </div>
    
   <div id="score_container" class="container">
  
     <div id="score_section" class="" ng-hide="!checkShowScores()">
       <div> {{data.show_answer_points}}  </div>
       Leaderboard
          <table id="table_score" class="table">
             <tr class="score_row" section="list" ng-repeat="item in data.scores track by item.player">
               <td class="left_column">{{item.player}}</td>
               <td class="center_column" ng-hide="!checkNotify()">{{item.mobile_number}}</td>
               <td class="right_column">{{item.score}}</td>
           </tr>
           
         </table>
        
    </div>
      
       <div id="game_over_section" class="" ng-hide="!checkGameOver()">
          <div id="game_over_image" style="text-align:center">
            <img src="game_over.jpg" width="260" height="196" />
          </div>
      </div>  
   </div>
    
</div>
<div>
    <div id="footer"><a href="/answernow/?id=tn_answernow_games&player_id={{data.player_id}}">Return to Game List</a> </div>
    </div>
    </div>]]></template>
    </sp_widget>
</record_update>
